function MemorySeal_Load(self)	
	self:RegisterEvent('PLAYER_ENTERING_WORLD');

	self:SetScript("OnEvent", function(self, event, ...) MemorySeal_OnEvent(self, event, ...) end);
end

MEMORYSEAL_QUESTS = {43894, 43895, 43896, 43897, 43892, 43893, 43510};

function MemorySeal_Alert()
	name, amount, texturePath, earnedThisWeek, weeklyMax, totalMax, isDiscovered, quality = GetCurrencyInfo(1273);
		
	if (amount == 6 or UnitLevel("player") ~= 110) then
		return;
	end
	
	count = 0;
	
	for quest = 1, 6 do
		if (IsQuestFlaggedCompleted(MEMORYSEAL_QUESTS[quest])) then
			count = count + 1;
		end
	end
	
	if (count < 3) then
		PlaySound("RaidWarning");
		RaidNotice_AddMessage(RaidBossEmoteFrame, "Use your Dalaran Hearthstone and acquire all your seals now !\n(" .. count .. " seals out of 3 already acquired)", ChatTypeInfo["RAID_BOSS_EMOTE"]);
	end
end

function MemorySeal_OnEvent(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		MemorySeal_Wait(15, MemorySeal_Alert);
	end
end

MemorySeal = CreateFrame("FRAME", "MemorySeal");
MemorySeal_Load(MemorySeal);

local waitTable = {};
local waitFrame = nil;

function MemorySeal_Wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end